#include "openSE.h"
#include "Targa.h"

#define SURF_WIDTH		160
#define SURF_HEIGHT		120

class CExample4 : public CApplication
{
public:
	openSE*		surface;
	dword_*		buffer;

	dword_*		picture1;
	dword_*		picture2;

	CExample4() : CApplication()
	{
		m_width		= 640;
		m_height	= 480;
		m_name		= string( "Example4" );

		surface		= NULL;
		buffer		= NULL;

		picture1	= NULL;
		picture2	= NULL;
	}
	~CExample4() {}

	virtual void DoFrame( double _timeDelta );
	virtual void SceneInit();
	virtual void SceneEnd();

};

CApplication* CApplication::ApplicationCreate()
{
	return new CExample4;
}

void CApplication::ApplicationDestroy()
{
	delete this;
}

void CExample4::SceneInit()
{
	surface = new openSE;
	assert( surface );

	buffer = surface->Open( SURF_WIDTH, SURF_HEIGHT, GetDD() );
	assert( buffer );

	int dummy;
	picture1 = CTarga::LoadTGA( string( "tank.tga" ), dummy, dummy );
	assert( picture1 );

	picture2 = CTarga::LoadTGA( string( "kongsberg4s.tga" ), dummy, dummy );
	assert( picture2 );

}

void CExample4::SceneEnd()
{
	delete [] picture1;
	delete [] picture2;
	delete surface;
}

void CExample4::DoFrame( double _timeDelta )
{
	static int j = 0;
	static bool up = true;

	if( up )
		j++;
	else
		j--;

/*	for( int i=0; i<SURF_WIDTH*SURF_HEIGHT; i++ )
	{
		buffer[i] = blend( picture1[i], picture2[i], j );
	}*/

	// a little bit faster than the above...
	ColorBlend( buffer, picture1, picture2, j, SURF_WIDTH*SURF_HEIGHT );

	if( j==255 )
		up = false;
	else if( j == 0 )
		up = true;

	surface->Blit( GetDD() );

	Sleep( 10 );
}
