#include "openSE.h"

#define SURF_WIDTH		320
#define SURF_HEIGHT		200

class CExample2 : public CApplication
{
public:
	openSE*		SE;
	dword_*		surf;

	CExample2() : CApplication()
	{
		m_width		= 640;
		m_height	= 480;
		m_name		= string( "Example2" );

		SE			= NULL;
		surf		= NULL;
	}
	~CExample2() {}

	virtual void DoFrame( double _timeDelta );
	virtual void SceneInit();
	virtual void SceneEnd();
};

CApplication* CApplication::ApplicationCreate()
{
	return new CExample2;
}

void CApplication::ApplicationDestroy()
{
	delete this;
}

void CExample2::SceneInit()
{
	SE = new openSE();
	assert( SE );

	surf = SE->Open( SURF_WIDTH, SURF_HEIGHT, GetDD() );
	assert( surf );

}

void CExample2::SceneEnd()
{
	delete SE;
}

void CExample2::DoFrame( double _timeDelta )
{
	static int noise;
	static int carry;
	static int seed = 0x12345;

	for( int i=0; i<SURF_WIDTH*SURF_HEIGHT; i++ )
	{
        noise = seed;
        noise >>= 3;
        noise ^= seed;
        carry = noise & 1;
        noise >>= 1;
        seed >>= 1;
        seed |= (carry << 30);
        noise &= 0xFF;
        surf[i] = (noise<<16) | (noise<<8) | noise;
	}

	SE->Blit( GetDD() );
}
