#if !defined(AFX_OPENSE_H__DBA4127B_3BBA_41C7_ABFF_9B30BC5238C1__INCLUDED_)
#define AFX_OPENSE_H__DBA4127B_3BBA_41C7_ABFF_9B30BC5238C1__INCLUDED_


#define WIN32_LEAN_AND_MEAN
#include <ddraw.h>
#include <windows.h>
#include <mmsystem.h>

#include <cassert>
#include <string>
using namespace std;

#include "Draw.h"
#include "Application.h"
#include "Timer.h"
#include "Color.h"
#include "Types.h"

// Main class
class openSE
{
private:
	enum eConverter
	{
		C_FAILED = 0,
		C_32RGB888,
		C_32BGR888,
		C_24RGB888,
		C_24BGR888,
		C_16RGB565,
		C_16BGR565,
		C_16RGB555,
		C_16BGR555,
		NUM_CONVERTERS
	};

	// Our 32 bit integer buffer
	dword_*					buffer;

	// Local buffer
	LPDIRECTDRAWSURFACE7	m_pDDS;
	CONVERTER				GetConverter();

	int						m_width;
	int						m_height;

protected:
	// Local buffer format
	CONVERTER				Convert;


public:
	openSE();
	~openSE();

	dword_*					Open( const int _width, const int _height, const CDDraw* _ddraw );
	void					Close();

	void					Clear( const dword_ _color );
	void					Blit( const CDDraw* _ddraw );
};

#endif // !defined(AFX_OPENSE_H__DBA4127B_3BBA_41C7_ABFF_9B30BC5238C1__INCLUDED_)
