//
// open.SE by maq
// www.fhskd.shfsd
//

#include "..\include\openSE.h"


// Application global..
CApplication* pApp = NULL;

	
int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	pApp = CApplication::ApplicationCreate();

	pApp->Init( hInstance );
	pApp->SceneInit();

	pApp->Run();

	pApp->SceneEnd();
	pApp->End();

	if( pApp )
		delete pApp;

	return 0;
}

LRESULT CALLBACK WndProc( HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam )
{
	int result = 0;

	// handle message
	switch( msg )
	{
#ifdef __SE_WINDOWED__
		case WM_CREATE:
		{
			pApp->m_bActive = true;
		}
		case WM_PAINT:
		{
			if( pApp->m_bActive && pApp->ddraw )
			{
				pApp->ddraw->m_pddsPrimary->Restore();
				pApp->ddraw->m_pddsBackBuffer->Restore();
			}
			// Call default window painting
			result = DefWindowProc( hWnd, msg, wParam, lParam );
			break;
		}
		case WM_SIZE:
		{
			if( wParam == SIZE_MINIMIZED )
			{
				pApp->m_bActive = false;
			}
			else if( !LOWORD(lParam) || !HIWORD(lParam) )
			{
				// One of the dimensions is 0, stop rendering.
				pApp->m_bActive = false;
			}
			else
			{
				pApp->m_bActive = true;
			}
		}
		case WM_MOVE:
		{
			pApp->UpdateRectangles();
			break;
		}
		case WM_ACTIVATEAPP:
		{                                       
			// Update active flag
#pragma warning( push )
#pragma warning( disable : 4800 )
			pApp->m_bActive = (bool)wParam;
#pragma warning( pop ) 
			break;
		}
#endif

#ifdef __SE_FULLSCREEN__
		case WM_SETCURSOR:
		{
			// Hide cursor
			SetCursor( 0 );
			break;
		}
#endif

		case WM_KEYDOWN:
		{
			// Close on escape key
			if( (wParam&0xFF) != 27 )
				break;
		}
		case WM_CLOSE:
		{
			if( pApp )
			{
				pApp->SceneEnd();
				pApp->End();
			}

			ExitProcess(0);
			break;
        }

		default:
		{
			// Unhandled messages
			result = DefWindowProc( hWnd, msg, wParam, lParam );
		}
	}

	return result;
}
